# Created by RuleJustification
# Sun Feb 24 13:36:55 CET 2013

(* Additional include (for proofs!) *)
include
  "proveHelper.p"

include
  "$proposition.p"




rule forall_right
  find |- (\forall %x;%b)
  samegoal
    replace $$subst(%x as %'x,$$skolem(%x as %'x) as %'x,%b as bool) as bool
  tags
    rewrite "fol simp"

rule exists_right
  find |- (\exists %x;%b)
  where interact %inst as %'inst
  samegoal
    add |- $$subst(%x as %'inst,%inst as %'inst,%b as bool) as bool
  tags
    dragdrop "6"

rule exists_right_hide
  find |- (\exists %x;%b)
  where interact %inst as %'inst
  samegoal
    replace $$subst(%x as %'inst,%inst as %'inst,%b as bool) as bool
  tags
    dragdrop "6"
    hiding "find"

rule forall_left
  find (\forall %x;%b) |-
  where interact %inst as %'inst
  samegoal
    add $$subst(%x as %'inst,%inst as %'inst,%b as bool) as bool |-
  tags
    dragdrop "6"

rule forall_left_hide
  find (\forall %x;%b) |-
  where interact %inst as %'inst
  samegoal
    replace $$subst(%x as %'inst,%inst as %'inst,%b as bool) as bool
  tags
    dragdrop "6"
    hiding "find"

rule exists_left
  find (\exists %x;%b) |-
  samegoal
    replace $$subst(%x as %'x,$$skolem(%x as %'x) as %'x,%b as bool) as bool
  tags
    rewrite "fol simp"

rule forall_remove
  find (\forall %x as %'x;%b as bool) as bool
  where freshVar %x as %'x, %b as bool
  samegoal
    replace %b as bool
  tags
    rewrite "fol simp"
    derived ""

rule exists_remove
  find (\exists %x as %'x;%b as bool) as bool
  where freshVar %x as %'x, %b as bool
  samegoal
    replace %b as bool
  tags
    rewrite "fol simp"
    derived ""

rule typed_forall_left
  find (\T_all %'a;(\forall %x;%b)) |-
  where interact %inst as %'inst, true as bool
  samegoal
    add $$polymorphicSubst(%x as %'a,%inst as %'inst,%b as bool) as bool |-
  tags
    dragdrop "7"

rule typed_forall_left_hide
  find (\T_all %'a;(\forall %x;%b)) |-
  where interact %inst as %'inst, true as bool
  samegoal
    replace $$polymorphicSubst(%x as %'a,%inst as %'inst,%b as bool) as bool
  tags
    dragdrop "7"
    hiding "find"

rule type_quant_left
  find (\T_all %'a;%b) |-
  where interact %inst as %'inst, true as bool
  samegoal
    add $$unifyTypes(type as %'a,type as %'inst,%b as bool) as bool |-
  tags
    dragdrop "4"

rule type_quant_left_hide
  find (\T_all %'a;%b) |-
  where interact %inst as %'inst, true as bool
  samegoal
    replace $$unifyTypes(type as %'a,type as %'inst,%b as bool) as bool
  tags
    dragdrop "4"
    hiding "find"

rule type_quant_right
  find |- (\T_all %'a;%b)
  samegoal
    replace $$unifyTypes(type as %'a,$$skolemType(type as %'a) as %'v6,%b as bool) as bool
  tags
    rewrite "fol simp"

rule equality_refl
  find $eq(%t as %'t,%t as %'t) as bool
  samegoal
    replace true as bool
  tags
    rewrite "concrete"
    verbosity "8"

rule equality_comm
  find $eq(%t as %'u,%u as %'u) as bool
  samegoal
    replace $eq(%u as %'u,%t as %'u) as bool

rule equality_order
  find $eq(%t,%u) |-
  where unorderedTerms %t as %'u, %u as %'u
  samegoal
    replace $eq(%u as %'u,%t as %'u) as bool
  tags
    rewrite "fol simp"
    verbosity "8"

rule equality_apply
  find %t as %'u
  assume $eq(%t,%u) |-
  where toplevel 
  samegoal
    replace %u as %'u
  tags
    dragdrop "8"
    verbosity "6"

rule equality_apply_reverse
  find %t as %'t
  assume $eq(%u,%t) |-
  where toplevel 
  samegoal
    replace %u as %'t
  tags
    dragdrop "8"
    verbosity "6"

rule auto_equality_apply
  find %t as %'u
  assume $eq(%t,%u) |-
  where toplevel 
  where distinctAssumeAndFind 
  where unorderedTerms %t as %'u, %u as %'u
  samegoal
    replace %u as %'u
  tags
    autoonly ""
    verbosity "6"

rule equality_unique
  find $eq(%t as %'u,%u as %'u) as bool
  where isUnique %t as %'u
  where isUnique %u as %'u
  samegoal
    replace $$resolveUnique(%t as %'u,%u as %'u) as bool
  tags
    rewrite "fol simp"
    verbosity "8"

rule cond_true
  find cond(true as bool,%a as %'b,%b as %'b) as %'b
  samegoal
    replace %a as %'b
  tags
    rewrite "concrete"
    verbosity "8"

rule cond_false
  find cond(false as bool,%a as %'b,%b as %'b) as %'b
  samegoal
    replace %b as %'b
  tags
    rewrite "concrete"
    verbosity "8"

rule cond_known_left
  find cond(%c as bool,%a as %'b,%b as %'b) as %'b
  assume %c |-
  samegoal
    replace %a as %'b
  tags
    rewrite "fol simp"
    derived ""
    verbosity "8"

rule cond_known_right
  find cond(%c as bool,%a as %'b,%b as %'b) as %'b
  assume |- %c
  samegoal
    replace %b as %'b
  tags
    rewrite "fol simp"
    derived ""
    verbosity "8"


function 'b a
function 'b b
function bool c


problem
  $not($and($impl($eq(cond(c as bool,a as 'b,b as 'b) as 'b,a as 'b) as bool,$not(c as bool) as bool) as bool,$impl($eq(cond(c as bool,a as 'b,b as 'b) as 'b,b as 'b) as bool,c as bool) as bool) as bool) as bool
