# Created by RuleJustification
# Wed Mar 06 10:51:54 CET 2013

(* Additional include (for proofs!) *)
include
  "proveHelper.p"

include
  "$int.p"
  "$set.p"
  "$seqdefs.p"




rule seqSubSelf
  find seqSub(%a as seq(%'v1),0 as int,seqLen(%a as seq(%'v1)) as int) as seq(%'v1)
  samegoal
    replace %a as seq(%'v1)
  tags
    rewrite "concrete"
    derived ""

rule seqOutside1
  find seqGet(%a as seq(%'v1),%i as int) as %'v1
  assume $lt(%i,0) |-
  samegoal
    replace seqError as %'v1
  tags
    derived ""

rule seqOutside2
  find seqGet(%a as seq(%'v1),%i as int) as %'v1
  assume $gte(%i,seqLen(%a)) |-
  samegoal
    replace seqError as %'v1
  tags
    derived ""

rule seqOutside3
  find |- $eq(seqError,seqGet(%s,%i))
  samegoal
    replace $or($lt(%i as int,0 as int) as bool,$lte(seqLen(%s as seq(%'v3)) as int,%i as int) as bool) as bool
  tags
    rewrite "fol simp"
    derived ""

rule lenOfSeqEmpty
  find seqLen(seqEmpty as seq(%'v2)) as int
  samegoal
    replace 0 as int
  tags
    rewrite "concrete"
    derived ""

rule getOfSeqEmpty
  find seqGet(seqEmpty as seq(%'v2),%i as int) as %'v2
  samegoal
    replace seqError as %'v2
  tags
    rewrite "concrete"
    derived ""

rule lenOfSeqSingleton
  find seqLen(seqSingleton(%x as %'x) as seq(%'x)) as int
  samegoal
    replace 1 as int
  tags
    rewrite "fol simp"
    derived ""

rule getOfSeqSingleton
  find seqGet(seqSingleton(%x as %'x) as seq(%'x),%i as int) as %'x
  samegoal
    replace cond($eq(%i as int,0 as int) as bool,%x as %'x,seqError as %'x) as %'x
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule lenOfSeqConcat
  find seqLen(seqConcat(%seq as seq(%'v2),%seq2 as seq(%'v2)) as seq(%'v2)) as int
  samegoal
    replace $plus(seqLen(%seq as seq(%'v2)) as int,seqLen(%seq2 as seq(%'v2)) as int) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule getOfSeqConcat
  find seqGet(seqConcat(%seq as seq(%'v7),%seq2 as seq(%'v7)) as seq(%'v7),%i as int) as %'v7
  samegoal
    replace cond($and($lte(0 as int,%i as int) as bool,$lt(%i as int,seqLen(%seq as seq(%'v7)) as int) as bool) as bool,seqGet(%seq as seq(%'v7),%i as int) as %'v7,seqGet(%seq2 as seq(%'v7),$minus(%i as int,seqLen(%seq as seq(%'v7)) as int) as int) as %'v7) as %'v7
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule lenOfSeqAppend
  find seqLen(seqAppend(%seq as seq(%'app),%app as %'app) as seq(%'app)) as int
  samegoal
    replace $plus(seqLen(%seq as seq(%'app)) as int,1 as int) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule getOfSeqAppend
  find seqGet(seqAppend(%seq as seq(%'app),%app as %'app) as seq(%'app),%i as int) as %'app
  samegoal
    replace cond($eq(%i as int,seqLen(%seq as seq(%'app)) as int) as bool,%app as %'app,seqGet(%seq as seq(%'app),%i as int) as %'app) as %'app
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule seqLenOfSub
  find seqLen(seqSub(%a as seq(%'v2),%from as int,%to as int) as seq(%'v2)) as int
  samegoal
    replace cond($lte(%from as int,%to as int) as bool,$minus(%to as int,%from as int) as int,0 as int) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule seqGetOfSub
  find seqGet(seqSub(%a as seq(%'v5),%from as int,%to as int) as seq(%'v5),%i as int) as %'v5
  samegoal
    replace cond($and($lte(0 as int,%i as int) as bool,$lt(%i as int,$minus(%to as int,%from as int) as int) as bool) as bool,seqGet(%a as seq(%'v5),$plus(%i as int,%from as int) as int) as %'v5,seqError as %'v5) as %'v5
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule lenOfSeqReverse
  find seqLen(seqReverse(%seq as seq(%'v2)) as seq(%'v2)) as int
  samegoal
    replace seqLen(%seq as seq(%'v2)) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule getOfSeqReverse
  find seqGet(seqReverse(%seq as seq(%'v2)) as seq(%'v2),%i as int) as %'v2
  samegoal
    replace seqGet(%seq as seq(%'v2),$minus($minus(seqLen(%seq as seq(%'v2)) as int,1 as int) as int,%i as int) as int) as %'v2
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule seqConcatWithSeqEmpty1
  find seqConcat(%seq as seq(%'v2),seqEmpty as seq(%'v2)) as seq(%'v2)
  samegoal
    replace %seq as seq(%'v2)
  tags
    rewrite "concrete"
    derived ""

rule seqConcatWithSeqEmpty2
  find seqConcat(seqEmpty as seq(%'v2),%seq as seq(%'v2)) as seq(%'v2)
  samegoal
    replace %seq as seq(%'v2)
  tags
    rewrite "concrete"
    derived ""

rule seqReverseOfSeqEmpty
  find seqReverse(seqEmpty as seq(%'v2)) as seq(%'v2)
  samegoal
    replace seqEmpty as seq(%'v2)
  tags
    rewrite "concrete"
    derived ""

rule seqReverseOfReverse
  find seqReverse(seqReverse(%s as seq(%'v2)) as seq(%'v2)) as seq(%'v2)
  samegoal
    replace %s as seq(%'v2)
  tags
    rewrite "concrete"
    derived ""


function int a
function seq('v1) s


problem
  $eq(seqSub(s as seq('v1),a as int,a as int) as seq('v1),seqEmpty as seq('v1)) as bool
